try:
	import psyco
	psyco.full()
except:
	pass
import sys

print '%s: version 2.0' % sys.argv[0]
if len(sys.argv) < 4:
	print 'usage: python %s label regionfile outbedfile [-color r,g,b] [-score field]\n' % sys.argv[0]
	print '\twhere color is in comma-delimited RGB without space'
        print '\tand field is a column with a score (first column is 0, second is 1,...)\n'  
	sys.exit(1)

factorlabel = sys.argv[1]
regionfile = open(sys.argv[2])
outfile = open(sys.argv[3], 'w')

color = '0,0,0'
if '-color' in sys.argv:
    color = sys.argv[sys.argv.index('-color') + 1]

scoreField = None
if '-score' in sys.argv:
    scoreField = int(sys.argv[sys.argv.index('-score') + 1])

outfile.write('track name=%s visibility=4 color=%s\n' % (factorlabel, color))
for line in regionfile:
    if line[0] == '#':
        continue
    fields = line.strip().split()
    if scoreField:
        score = int(float(fields[scoreField]))
        if score > 1000:
            score = 1000
        outfile.write('%s\t%s\t%s\t%s\t%d\n' % (fields[1], fields[2], fields[3], fields[0], score))
    else:
        outfile.write('%s\t%s\t%s\t%s\n' % (fields[1], fields[2], fields[3], fields[0]))
outfile.close()
